﻿(function () {

    "use strict";

    angular.module("enrNavBarModule", [])
           .directive("enrNavBar", [function () {
               return {
                   templateUrl: "Scripts/EnrAngular/Directives/enrNavBar.html",
                   scope: {},
                   controller: "enrNavBarController",
                   restrict: "E"
               };
           }])
           .controller("enrNavBarController", ["$scope", "$rootScope", "$timeout", "enrModeManager", function ($scope, $rootScope, $timeout, enrModeManager) {
               var handleModeChange = function(newMode) {
                   $scope.officeItemClass = "nav";
                   $scope.refItemClass = "nav";

                   if (newMode === enrModeManager.modeEnum.offices)
                       $scope.officeItemClass += " active";
                   else
                       $scope.refItemClass += " active";
               }
               handleModeChange(enrModeManager.getCurMode());

               $scope.navItemClicked = function (index) {
                   var newMode = index === 0 ? enrModeManager.modeEnum.offices : enrModeManager.modeEnum.referendums;

                   // This could take some time. Show busy working.
                   $rootScope.$broadcast("PUSH_BUSY_WORKING");
                   // Delay execution of syncronous logic to give the busy working effect time to appear before causing ui-locking.
                   $timeout(function () { enrModeManager.setCurMode(newMode); }, 500);
                   
               }
               $scope.$on(enrModeManager.modeChangeEventName, function (event, newMode) {
                   handleModeChange(newMode);
               });
           }]);

}());



